Package: phosphoricons
Title: 'Phosphor' Icons for R
Version: 0.2.1
Authors@R: 
    c(person(given = "Victor",
             family = "Perrier",
             role = c("aut", "cre", "cph"),
             email = "victor.perrier@dreamrs.fr"),
      person(given = "Fanny",
             family = "Meyer",
             role = "aut"),
      person(given = "Phosphor Icons",
             role = "cph",
             comment = "Phosphor Icons <https://github.com/phosphor-icons>"))
Description: Use 'Phosphor' icons in 'shiny' applications or 'rmarkdown' documents. Icons are available in
    5 different weights and can be customized by setting color, size, orientation and more.
License: MIT + file LICENSE
Encoding: UTF-8
RoxygenNote: 7.3.1
Depends: R (>= 2.10)
Imports: htmltools (>= 0.3)
Suggests: covr, shiny, tinytest
URL: https://dreamrs.github.io/phosphoricons/,
        https://github.com/dreamRs/phosphoricons
BugReports: https://github.com/dreamRs/phosphoricons/issues
NeedsCompilation: no
Packaged: 2024-04-08 05:45:05 UTC; perri
Author: Victor Perrier [aut, cre, cph],
  Fanny Meyer [aut],
  Phosphor Icons [cph] (Phosphor Icons
    <https://github.com/phosphor-icons>)
Maintainer: Victor Perrier <victor.perrier@dreamrs.fr>
Repository: CRAN
Date/Publication: 2024-04-08 06:12:59 UTC
Built: R 4.6.0; ; 2026-04-27 07:08:53 UTC; unix

<!-- README.md is generated from README.Rmd. Please edit that file -->

# phosphoricons

<!-- badges: start -->

[![version](http://www.r-pkg.org/badges/version/phosphoricons)](https://CRAN.R-project.org/package=phosphoricons)
[![](https://cranlogs.r-pkg.org/badges/phosphoricons?color=brightgreen)](https://cran.r-project.org/package=phosphoricons)
[![Codecov test
coverage](https://codecov.io/gh/dreamRs/phosphoricons/branch/master/graph/badge.svg)](https://app.codecov.io/gh/dreamRs/phosphoricons?branch=master)
[![R-CMD-check](https://github.com/dreamRs/phosphoricons/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/dreamRs/phosphoricons/actions/workflows/R-CMD-check.yaml)
<!-- badges: end -->

R wrapper for using [Phosphor
Icons](https://github.com/phosphor-icons/web) in shiny applications or
rmarkdown documents. Visit
[phosphoricons.com](https://phosphoricons.com/) for a list of all
available icons.

## Installation

Install from CRAN with:

``` r
install.packages("phosphoricons")
```

You can install development version from GitHub with:

``` r
remotes::install_github("dreamRs/phosphoricons")
```

## Icons usage

Create an icon with `ph()` function:

``` r
library(phosphoricons)
ph("lightning")
```

<img src="man/figures/lightning-light.svg" height="32" />

There’s 5 weights available:

``` r
ph("lightning", weight = "thin")
```

<img src="man/figures/lightning-thin.svg" height="32" />

``` r
ph("lightning", weight = "light")
```

<img src="man/figures/lightning-light.svg" height="32" />

``` r
ph("lightning", weight = "regular")
```

<img src="man/figures/lightning-regular.svg" height="32" />

``` r
ph("lightning", weight = "bold")
```

<img src="man/figures/lightning-bold.svg" height="32" />

``` r
ph("lightning", weight = "fill")
```

<img src="man/figures/lightning-fill.svg" height="32" />

Colorize icon using `fill` argument:

``` r
ph("lightning", weight = "bold", fill = "gold")
```

<img src="man/figures/lightning-bold-gold.svg" height="32" />

There’s two type of icons:

- SVG icons, created with `ph()`
- Font icons, created with `ph_i()`

There’s a big debate between Web Fonts vs SVG for icons, but mainly:

- Web fonts require an `htmlDependency` that include all icons even if
  you use one, it will increase the size of your document in self
  contained mode.
- SVG icons won’t currently work with some shiny functions with an
  `icon` argument.

## Bonus

Fill icon according to percentage:

``` r
ph_fill(
  ph("heart", weight = "fill", height = 128),
  colors = c("#DF0101", "#F6CECE"),
  breaks = 0.7
)
```

<img src="man/figures/icon-fill-perc-1.svg" height="128" />

``` r
ph_fill(
  ph("star", weight = "fill", height = 128, stroke = "gold", `stroke-width` = 10),
  colors = c("gold", "#FFF"),
  breaks = 0.5,
  orientation = "h"
)
```

<img src="man/figures/icon-fill-perc-2.svg" height="128" />

Icon waffle:

``` r
waffle_icon(
  values = sample(c("Cats", "Dogs"), 200, TRUE),
  colors = list(
    Cats = "#456990",
    Dogs = "#F45B69"
  ),
  icons = list(
    Cats = ph("cat", height = NULL),
    Dogs = ph("dog", height = NULL)
  ),
  ncol = 15,
  nrow = 8,
  width = "500px"
)
```

![](man/figures/waffle.png)

waffle <- waffle_icon(
  values = sort(sample(c("Aa", "Bb", "Cc"), 100, TRUE)),
  colors = c("#81F4E1", "#56CBF9", "#FF729F"),
  icons = ph("user", weight = "fill", height = 32)
)
expect_inherits(waffle, "shiny.tag")
expect_true(grepl(
  pattern = "phosphor-waffle-legend",
  x = as.character(waffle)
))

waffle <- waffle_icon(
  values = sort(sample(c("Aa", "Bb", "Cc"), 100, TRUE)),
  colors = c("#81F4E1", "#56CBF9", "#FF729F"),
  icons = ph("user", weight = "fill", height = 32),
  legend = FALSE
)
expect_inherits(waffle, "shiny.tag")
expect_false(grepl(
  pattern = "phosphor-waffle-legend",
  x = as.character(waffle)
))


expect_error(
  waffle_icon(
    values = sort(sample(c("Aa", "Bb", "Cc"), 100, TRUE)),
    colors = c("#81F4E1", "#56CBF9", "#FF729F", "blue"), # extra color
    icons = ph("user", weight = "fill", height = 32)
  )
)

expect_error(
  waffle_icon(
    values = sort(sample(c("Aa", "Bb", "Cc"), 100, TRUE)),
    colors = c("#81F4E1", "#56CBF9", "#FF729F"), 
    icons = list(
      Aa = ph("user", weight = "fill", height = 32) # if list, must have 3 icon
    )
  )
)


waffle <- waffle_icon(
  values = as.factor(sample(c("Cats", "Dogs"), 200, TRUE)),
  colors = list(
    Cats = "#456990",
    Dogs = "#F45B69"
  ),
  icons = list(
    Cats = ph("cat", height = NULL),
    Dogs = ph("dog", height = NULL)
  ),
  ncol = 15,
  nrow = 8,
  width = "500px"
)
expect_inherits(waffle, "shiny.tag")

expect_error(
  waffle_icon(
    values = as.factor(sample(c("Cats", "Dogs"), 200, TRUE)),
    colors = list(
      Cats = "#456990",
      Dogs = "#F45B69"
    ),
    icons = list(
      ph("cat", height = NULL),
      ph("dog", height = NULL)
    ),
    ncol = 15,
    nrow = 8,
    width = "500px"
  )
)


expect_true(phosphoricons:::is_named(list(a = 1, b = 2)))
expect_false(phosphoricons:::is_named(list(1, 2)))
expect_false(phosphoricons:::is_named(list(a = 1, 2)))

icon <- ph_i("number-circle-two")
expect_inherits(icon, "shiny.tag")
expect_identical(icon$name, "i")

expect_error(ph_i("donotexist"))
expect_error(ph_i(c("heart", "star")))

expect_identical(
  htmltools::findDependencies(icon),
  list(html_dependency_phosphor())
)


icon <- ph_i("number-circle-two", size = "5x")
expect_true(grepl("ph-5x", x = icon$attribs$class))

icon <- ph_i("number-circle-two", weight = "fill")
expect_true(grepl("fill", x = icon$attribs$class))

icon <- ph_i("number-circle-two", weight = "regular")
expect_false(grepl("regular", x = icon$attribs$class))

icon <- ph("user")
expect_inherits(icon, "shiny.tag")
expect_identical(icon$name, "svg")

expect_error(ph("donotexist"))
expect_error(ph(c("heart", "star")))
expect_warning(ph("number-circle"))
expect_silent(ph("number-circle-eigh")) # only one match

icon <- ph("user", height = NULL, width = "48px", fill = "red", rotate = 45)
expect_identical(icon$attribs$fill, "red")
expect_identical(icon$attribs$width, "48px")
expect_null(icon$attribs$height)
expect_true(grepl("transform:rotate(45deg)", x = icon$attribs$style, fixed = TRUE))


icon <- ph("user", title = "my title")
children_nm <- unlist(lapply(icon$children, `[[`, "name"))
expect_true("title" %in% children_nm)
expect_identical(icon$children[[length(icon$children)]], htmltools::tags$title("my title"))

icon <- ph("user", title = NULL)
children_nm <- unlist(lapply(icon$children, `[[`, "name"))
expect_false("title" %in% children_nm)

icon <- ph_fill(
  ph("heart", weight = "fill", height = 128),
  colors = c("#DF0101", "#F6CECE"),
  breaks = 0.7
)
expect_inherits(icon, "shiny.tag")
expect_identical(icon$name, "svg")

expect_true(grepl(pattern = "linearGradient", x = as.character(icon)))



expect_error(ph_fill(
  ph("heart", weight = "fill", height = 128),
  colors = c("#DF0101", "#F6CECE"),
  breaks = c(0.2, 0.7)
))

expect_error(ph_fill(
  ph("heart", weight = "fill", height = 128),
  colors = c("#DF0101", "#F6CECE"),
  breaks = 12
))

expect_error(ph_fill(
  list(),
  colors = c("#DF0101", "#F6CECE"),
  breaks = 0.7
))

expect_error(ph_fill(
  ph_i("heart", weight = "fill"),
  colors = c("#DF0101", "#F6CECE"),
  breaks = 0.7
))

expect_error(search_icon(c("tralilala", "youpilou")))

expect_warning(no_results <- search_icon("tralilala"))
expect_identical(no_results, character(0))

numbers <- search_icon("number", output = "console")
expect_true(length(numbers) > 0)
expect_inherits(numbers, "character")

numbers <- search_icon("number", output = "viewer")
expect_inherits(numbers, "shiny.tag")
